#include "Arduino.h"
#include "Reaper.h"

Reaper::Reaper()
{
  _init();
}

// initialise tracks, selected track, selected insert & parameters
void Reaper::_init(){
  for (int i=0;i<NUM_OF_TRACKS;i++){
    _initTrack(&track[i]);
  }
  _initTrack(&selectedTrack);
  for (int i=0;i<NUM_OF_PARAMETERS;i++){
    _initOscParameter(&insertParameter[i]);
  }
  _initInsert(&selectedInsert);
}

// initialise Track struct with default values
void Reaper::_initTrack(Track *track){
  track->number=1;
  track->volume=0.0;
  track->pan=0.0;
  track->rec=0;
  track->mute=0;
  track->solo=0;
  track->monitor=0;
  for (int s=0;s<NUM_OF_SENDS;s++){
    TrackSend *send=&track->send[s];
    send->number=0;
    send->volume=0.0;
    send->pan=0.0;
  }
  for (int k=0;k<NUM_OF_INSERTS;k++){
    TrackInsert *insert=&track->insert[k];
    insert->number=0;
    insert->bypass=1;
  }
}


// initialise Insert struct with default values
void Reaper::_initInsert(TrackInsert *insert){
  insert->number=1;
  insert->bypass=0;
}

// initialise OSC parameter struct with default values
void Reaper::_initOscParameter(OscParameter *parameter){
  parameter->number=0;
  parameter->value=0.0;
}
